/* myftpclient.c
*   part of trxamadrm package
*
*   Author M.Bos - PA0MBO
*
*   date Nov 8th 2014
*/

#include <stdio.h>  
#include <stdlib.h>  
#include <string.h>  
#include <time.h>  
#include <unistd.h>  
#include <pthread.h>  
#include <errno.h>  
#include <netinet/in.h>  
#include <sys/socket.h>  
#include <netdb.h>  
#include <locale.h>
#include <langinfo.h>  
      
struct argsforlistenthread 
     {
       int sockid;
       FILE *fp;
     }  ;

/* globals */
int err=1;  
unsigned int lport;
  
/* utility procedures */      
int sockopen (char *host, int port)  {  
    int sd;  
    char ip[INET6_ADDRSTRLEN];  
    struct sockaddr_in server;  
    struct hostent *h;  
            
    if ((sd=socket(AF_INET,SOCK_STREAM,0))<0)  {  
           return -1;  
    }  
          
    if (!(h=gethostbyname(host)))  {  
           return -1;  
    }  
      
    snprintf (ip,sizeof(ip),"%u.%u.%u.%u",  
              h->h_addr[0]&0xFF,h->h_addr[1]&0xFF,h->h_addr[2]&0xFF,h->h_addr[3]&0xFF);  
      
    server.sin_family=h->h_addrtype;  
    server.sin_port=htons((unsigned short) port);  
    server.sin_addr.s_addr=inet_addr(ip);  
      
    if (connect(sd, (struct sockaddr*) &server, sizeof(struct sockaddr))<0)  {  
            return -1;  
    }  
     
    return sd;  
}  
      
      
void* read_thread (void *arg)
{  
   int *sd = (int*) arg;  
   char ch;  
      
   while (recv(*sd,&ch,1,0)>0)  
        printf ("%c",ch);  
      
   pthread_exit(0);  
   return NULL;  
}  
      
void* listen_loop (void *arg)
{  
   struct argsforlistenthread *myargs = arg;
   int sd = (*myargs).sockid;
   FILE *fp= (*myargs).fp; 
   int my_sd;  
   int len=sizeof(struct sockaddr);  
   char ch;  
   struct sockaddr_in client;  
      
   if (listen(sd,1)<0)  
       pthread_exit(&err);  
      
   while (1) 
   {  
      if ((my_sd=accept(sd, (struct sockaddr*) &client, &len))<0) 
      {
         printf("quitting listen_loop \n");                            
             pthread_exit(&err);  
      } 
      else 
      {
        /*  printf("my_sd is %d\n", my_sd); */
      }
      while (recv(my_sd,&ch,1,0)>0) 
      {
        /*  printf ("%c",ch);  */
        fprintf(fp,"%c",ch);
      }            
      
      close(my_sd);  
   }  
      
   pthread_exit(0);  
   return NULL;  
}  
      
int main (void) 
 {  
    int c,sd,act_sd, i;  
    unsigned int port=21;  
    int slen=sizeof(struct sockaddr_in);  
    char buff[BUFSIZ],tmp[BUFSIZ],pcmd[BUFSIZ];  
    char user[50],pass[50],host[50],tmp2[50], dir[50];  
    struct sockaddr_in server,client;  
    pthread_t t,sock;  
    FILE *fp;
    unsigned char rxfilename[100];
    char modifiedrxname[100];
    char modifiedrxutf8[100];
    char filename_inihybrid[100];
    char *homedir;
    long int save_pos, filesize;
    struct argsforlistenthread argslistenloop ;

    /* check for character set */
    setlocale(LC_CTYPE, "");
    printf("%s\n",nl_langinfo(CODESET));
      
    srand ((unsigned) time(NULL));  
    lport=(rand()%64511)+1024;  
  
    /* get the server access data from hybrid.ini in home directory */
     homedir= getenv("HOME");
    /*  printf("Home dir is %s\n", homedir);    */
 /*    strcpy(filename_inihybrid, homedir);  */
     strcpy(filename_inihybrid,"/tmp/hybrid.ini");
     if (( fp=fopen(filename_inihybrid,"r")) == NULL)
     {
        printf("Cannot find %s\n", filename_inihybrid);
        exit(-1);
     }
     fgets(tmp,50, fp); 
     fgets(tmp,50, fp);  /* line 2 : ftpserver= */
     sscanf(strchr(tmp,'=')+1,"%s",host);
      printf("host is %s\n", host); 

     fgets(tmp,50,fp);
     fgets(tmp,50,fp);  /* regel 4 : user= */
     sscanf(strchr(tmp,'=')+1, "%s", user);
       printf("user is %s", user); 

     fgets(tmp,50,fp);  /* regel 5 : passwd= */
     sscanf(strchr(tmp,'=')+1, "%s", pass);
      printf("passwd is %s\n", pass);

     fgets(tmp,50, fp);
     fgets(tmp,50, fp); /* regel 7 : ftpdir= */
     sscanf(strchr(tmp, '=')+1, "%s", dir);
     printf("ftp dir is %s\n", dir);
            
     /* determine the original filename -> rxfilename */
     if (( fp=fopen("lastorgfname.txt","rb"))== NULL) 
     {
       printf("Cannot open lastorgfname.txt\n");
       exit(-1);
     }
     save_pos = ftell( fp );
     fseek(fp, 0L, SEEK_END);
     filesize= ftell(fp);
     fseek (fp, save_pos, SEEK_SET);
     fread(rxfilename, filesize, 1, fp);
     rxfilename[filesize]='\0';
     fclose(fp); 
     printf("na getting rxfilename %s\n", rxfilename);  

     /* modify original filename to no special characters etc. */
     strcpy(modifiedrxname,"./picsrx/");        
     /* printf("modified nu %s\n", modifiedrxname);  */
     strcpy(modifiedrxname+9, rxfilename+3);
     for (i=0; i < strlen(modifiedrxname); i++ )
     {
        if (modifiedrxname[i] < 0 )
               modifiedrxname[i]='_';
    }
    strxfrm(modifiedrxname, modifiedrxutf8, strlen(modifiedrxutf8));
    if (( fp=fopen(modifiedrxname,"wb")) == NULL)
    {
       printf("Cannot open %s for write \n", modifiedrxname);
       exit(-1);
    }
    else
    {
          printf("opened %s for write\n", modifiedrxname); 
    }

 
    /* printf("te halen hybrid file heet %s\n", modifiedrxname); */
             
    if ((sd=sockopen(host,port))<0) 
    {  
        printf ("Connection error: %s\n",strerror(errno));  
        exit(-1);  
    }  
      
    memset (buff,0,sizeof(buff));  
    snprintf (buff,sizeof(buff),"USER %s\r\n", user);
    send (sd,buff,strlen(buff),0);  
    sleep(1);

    memset (buff,0, sizeof(buff));
    snprintf (buff,sizeof(buff),"PASS %s\r\n", pass);
    send (sd,buff,strlen(buff),0);  
    sleep(1);    
      
    if (pthread_create(&t,NULL,read_thread,&sd)) 
    {  
       printf ("Error creating thread: %s\n",strerror(errno));  
       exit(-1);  
    }  
    sleep(2); 
    server.sin_family=AF_INET;  
    server.sin_port=htons((unsigned short) lport);  
    server.sin_addr.s_addr=INADDR_ANY;  
      
    if ((act_sd=socket(AF_INET,SOCK_STREAM,0))<0) 
    {  
       printf ("Unable to create socket: %s\n",strerror(errno));  
       exit(1);  
    }  
      
   if (bind(act_sd, (struct sockaddr*) &server, slen)<0) 
   {  
        printf ("Unable to bind socket: %s\n",strerror(errno));  
        exit(-1);  
   }  

   /* now set args in argslistenloop struct */

   argslistenloop.sockid = act_sd;
   argslistenloop.fp = fp;
 
   if (pthread_create(&sock,NULL,listen_loop,&argslistenloop)) 
   {  
        printf ("Error creating thread: %s\n",strerror(errno));  
        exit(-1);  
   }  
      
   memset (buff,0,sizeof(buff));  
     
   sleep(2);  
   getsockname(sd, (struct sockaddr*) &client, &slen);  
      
   snprintf (pcmd,sizeof(pcmd),"PORT %d,%d,%d,%d,%d,%d\r\n",  
          (client.sin_addr.s_addr & 0x000000FF),  
          (client.sin_addr.s_addr & 0x0000FF00) >> 8,  
          (client.sin_addr.s_addr & 0x00FF0000) >> 16,  
          (client.sin_addr.s_addr & 0xFF000000) >> 24,  
                           (lport & 0xFF00) >> 8,  
                           (lport & 0x00FF));  
      
        /*  printf("pcmd: %s", pcmd);   */

        /* change to HybridFiles1 directory */
   memset ( buff,0, sizeof(buff));
/*   printf("changing to dir HybridFiles1 \n"); */

   snprintf(buff, sizeof(buff), "CWD %s\r\n",dir);
   send( sd, buff,strlen(buff),0);
   sleep(2);
             
   memset ( buff, 0, sizeof(buff));
   snprintf(buff, sizeof(buff), "TYPE I\r\n");
   send( sd, buff, strlen(buff),0);
   sleep(2);
      
   /* get command */ 
   memset (buff,0,sizeof(buff));  
   snprintf (buff,sizeof(buff),"RETR %s\r\n",rxfilename);  
    printf("buff is nu %s\n", buff);  
   send (sd,pcmd,strlen(pcmd),0);  
   send (sd,buff,strlen(buff),0);  
   sleep(5); 

   /* Job done quit */
   memset (buff,0,sizeof(buff));  
   snprintf (buff,sizeof(buff),"QUIT");  
   send (sd,buff,strlen(buff),0);  
   printf ("Bye, bye\n");  
   sleep(2);     
   close(sd);  
   fclose(fp);
   if (( fopen("lasthybrid.txt","w"))== NULL)
   {
      printf("Cannot open lasthybrid for write \n");
      exit(-1);
   }
   fprintf(fp,"%s", modifiedrxname);
   fclose(fp);
   return 0;  
}  

