
/*
*   File drawblock.c
*
*   draws a block of pixels
*   M.Bos - PA0MBO
*   date Feb 21st 2009
*
*/

/*************************************************************************
*
*                           PA0MBO
*
*    COPYRIGHT (C)  2009  M.Bos 
*
*    This file is part of the distribution package RXAMADRM
*
*    This package is free software and you can redistribute is
*    and/or modify it under the terms of the GNU General Public License
*
*    More details can be found in the accompanying file COPYING
*************************************************************************/


#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>
#include <stdio.h>
#include <stdlib.h>		/* getenv(), etc. */
#include <unistd.h>		/* sleep(), etc.  */
#include <math.h>
#include <signal.h>

#define BLKSIZE 3
void drawblock(int x, int y, Display * display, GC theGC, Window mywin)
{
  int i, j, hblk;

  hblk = (int) floor(BLKSIZE / 2 + 0.5);
  for (i = x - hblk + 1; i < x - hblk + 1 + BLKSIZE; i++)

    {
      for (j = y - hblk + 1; j < y - hblk + 1 + BLKSIZE; j++)
	(void) XDrawPoint(display, mywin, theGC, i, j);
    } (void) XFlush(display);
}
