
/* 
*
*   File tstdraw.c -  pa0mbo
*
*
* M.Bos - pa0mbo
* Feb 21st 2009
*
*/

/*************************************************************************
*
*                           PA0MBO
*
*    COPYRIGHT (C)  2009  M.Bos 
*
*    This file is part of the distribution package RXAMADRM
*
*    This package is free software and you can redistribute it
*    and/or modify it under the terms of the GNU General Public License
*
*    More details can be found in the accompanying file COPYING
*************************************************************************/


#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>
#include <stdio.h>
#include <stdlib.h>		/* getenv(), etc. */
#include <unistd.h>		/* sleep(), etc.  */
#include <math.h>
#include <signal.h>
extern Display *display;
void dispfac(float *, int, Display *, GC, Window);
void
showFAC(float /*@null@ */ *meas, int count, char /*@null@ */ *argv[],
	int argc, int init)
{
  static Window masterwin, theMain;

  XWMHints xwmh;		/* hints for window manager */
  XSizeHints xsh;
  XSetWindowAttributes xswa;
  char appname[] = "FAC CONSTELLATIONS";
  static GC theGC;		/* graphic context for main */

  XGCValues gcv;		/* structure used to set fields in GC */
  XEvent evt;
  int screen_num;
  char *display_name = NULL;
  long eventMask;
  char *argv0;

  argv0 = argv[0];
  if (init)

    {

      /* open connection with the X server. */
      display = XOpenDisplay(display_name);
      if (display == NULL)

	{
	  fprintf(stderr, "%s: cannot connect to X server '%s'\n",
		  "FAC_display", display_name);
	  exit(EXIT_FAILURE);
	}

      /* get the geometry of the default screen for our display. */
      screen_num = DefaultScreen(display);
      theMain = RootWindow(display, screen_num);
      xsh.flags = (PPosition | PSize | PMinSize);
      xsh.height = 400;
      xsh.min_height = 20;
      xsh.width = 400;
      xsh.min_width = 20;
      xsh.x = 50;
      xsh.y = 100;
      masterwin =
	XCreateSimpleWindow(display, theMain, 0, 0, 400, 400, 0,
			    BlackPixel(display, screen_num),
			    WhitePixel(display, screen_num));
      XSetStandardProperties(display, masterwin, appname, appname, None, argv,
			     argc, &xsh);
      xwmh.flags = (InputHint | StateHint);
      xwmh.input = False;
      xwmh.initial_state = NormalState;
      XSetWMHints(display, masterwin, &xwmh);
      XMapWindow(display, masterwin);
      eventMask = StructureNotifyMask;
      XSelectInput(display, masterwin, eventMask);

      do
	{
	  XNextEvent(display, &evt);	/* calls XFlush  */
	}
      while (evt.type != MapNotify);
      gcv.foreground = BlackPixel(display, screen_num);
      gcv.background = WhitePixel(display, screen_num);
      gcv.line_width = 0;
      gcv.line_style = LineSolid;
      theGC =
	XCreateGC(display, masterwin,
		  GCForeground | GCBackground | GCLineWidth | GCLineStyle,
		  &gcv);
      xswa.colormap = DefaultColormap(display, screen_num);
      xswa.bit_gravity = NorthWestGravity;
      XChangeWindowAttributes(display, masterwin, (CWColormap | CWBitGravity),
			      &xswa);
      XSetForeground(display, theGC, 0);
      XSync(display, False);
    }

  else

    {
      XClearWindow(display, masterwin);
      XSync(display, False);
      XDrawLine(display, masterwin, theGC, 200, 0, 200, 400);
      XDrawLine(display, masterwin, theGC, 0, 200, 400, 200);
      dispfac(meas, count, display, theGC, masterwin);
      eventMask = ButtonPressMask | ButtonReleaseMask;
      XSelectInput(display, masterwin, eventMask);	/* override prev */

      /*  do {
         XNextEvent( display, &evt );   // calls XFlush()
         }while( evt.type != ButtonRelease );     
         XDestroyWindow( display, masterwin );
         XCloseDisplay( display ); */
    }
  return;
}
