#!/usr/bin/wish  -f
package require Tk
package require Expect
package require Img

proc ComSetup {ComPort ComRate} {
  global pttkind
  if { [ catch { set iChannel [open $ComPort w+] } ] } {
  puts "Cannot open device $ComPort exiting "
  exit
  }
#  set rate $ComRate
  set ComRate 9600
  fconfigure $iChannel -mode $ComRate,n,8,1
  fconfigure $iChannel -blocking 0
  fconfigure $iChannel -buffering none
  fileevent $iChannel readable ""
  return $iChannel
}


proc init_ptt  { modelnr devptt catbaud pttkind } {
  global ptt fdin 
  set ptt 0
  switch $pttkind {
    cat {
     puts " ptt cat"
     if { [ catch { exec  rigctl -m $modelnr -r $devptt -s $catbaud  T 0 } ] } {
     puts "rigctl missing ? wrong device ? baudrate ? - exiting"
     exit
     }  
    }
    rts {  
     puts " ptt rts "
      set fdin [ ComSetup  $devptt $catbaud ]
      fconfigure $fdin -handshake xonxoff
      fconfigure $fdin -ttycontrol {RTS 0 DTR 0}
     }
   dtr {
    puts " ptt dtr "
    set fdin [ ComSetup $devptt $catbaud ]
        fconfigure $fdin -handshake xonxoff
        fconfigure $fdin -ttycontrol {RTS 0 DTR 0}
        puts "ptt dtr configured"
     }
  default {
   puts "No  ptt method set "
  }
 }
}


proc WriteIni  { fname devout mode bw intlv qam prot callsign devptt catbaud modelnr rsencodenr pttkind} {
set fpiniw [open $fname w]
puts  $fpiniw "\[sounddevices\]"
puts $fpiniw "devin=0"
set output "devout=" 
append output $devout
puts $fpiniw  $output 
puts $fpiniw "\[mode\]"
set output "robustness="
append output $mode
puts $fpiniw  $output
set output "BW="
append output $bw
puts $fpiniw $output
set output "intlvldepth="
append output $intlv
puts $fpiniw $output
set output "qam="
append output $qam
puts $fpiniw $output
set output "protlev="
append output $prot
puts $fpiniw $output
puts $fpiniw "\[callsign\]"
set output "mycall="
append output $callsign
puts $fpiniw $output
puts $fpiniw "\[ptt\]"
set output "dev="
append output $devptt
puts $fpiniw $output
puts $fpiniw "\[baud\]"
set output "rate="
append output $catbaud
puts $fpiniw $output
set output "pttkind="
append output $pttkind
puts $fpiniw $output
puts $fpiniw "\[hamlib\]"
set output "model="
append output $modelnr
puts $fpiniw $output
puts $fpiniw "\[rsencoding\]"
set output "rsencodenr="
append output $rsencodenr
puts $fpiniw $output
close $fpiniw
#puts "fname is $fname"
}

proc rsencode { rsencodenr fileresp } {
  global filetosend 
  if { $rsencodenr == 0 } {
       set filetosend  $fileresp
     } elseif { $rsencodenr == 1} {
            exec ./rs1encode $fileresp
            set rs1filename [ file rootname $fileresp ]
            append rs1filename ".rs1"
            set filetosend $rs1filename
     } elseif { $rsencodenr == 2 } {
            exec ./rs2encode $fileresp
            set rs2filename [ file rootname $fileresp ]
            append rs2filename ".rs2"
            set filetosend $rs2filename
     } elseif { $rsencodenr == 3 } {
            exec ./rs3encode $fileresp
            set rs3filename [ file rootname $fileresp ]
            append rs3filename ".rs3"
            set filetosend $rs3filename
     } elseif { $rsencodenr == 4 } {
             exec ./rs4encode $fileresp
             set rs4filename [ file rootname $fileresp ]
             append rs4filename ".rs4"
             set filetosend $rs4filename
      }
}



proc ptt_on { modelnr devptt catbaud pttkind } {
  global ptt fdin
  switch $pttkind {
   cat {
    if { [ catch { exec rigctl -m $modelnr -r $devptt -s  $catbaud  T 1 } ] } {
    } 
   }
   dtr {
       fconfigure $fdin -ttycontrol {RTS 0 DTR 1}
    }
  rts {
       fconfigure $fdin -ttycontrol {RTS 1 DTR 0}
   }
 }
}

proc ptt_off { modelnr devptt catbaud pttkind } {
  global ptt fdin
  switch $pttkind {
   cat {
    if { [ catch { exec rigctl -m $modelnr -r $devptt -s  $catbaud  T 0 } ] } {
      } 
   }
   dtr {
        fconfigure $fdin -ttycontrol {RTS 0 DTR 0}
      }
  rts {
        fconfigure $fdin -ttycontrol {RTS 0 DTR 0}
  }
 }
}


proc calcdisp_eta { fileresp } {
  global mode qam rsencodenr .c.c6a.etasec eta 
  set filesize [ file size $fileresp ]
  puts "filesize is "
  puts $filesize
# now calculate eta from size and tx-condx
if { $mode == 0 } {
   if { $qam == 4 } {
    set tfact 2
   } else {
    set tfact 1
  }
}
if { $mode == 1 } {
  if { $qam == 4 } {
    set tfact 3
  } else {
  if { $qam == 16 } {
    set tfact 2
  } else {
    set tfact 1
  } 
 }
}
if { $mode == 2 } {
  if { $qam == 4 } {
    set tfact 4 
  } else {
    set tfact 2
  }
}

set eta [ expr $filesize * $tfact / 330 ]

switch $rsencodenr {
0  {  }
1  { set eta [ expr $eta * 255 / 224 ] }
2  { set eta [ expr $eta * 255 / 192 ] }
3  { set eta [ expr $eta * 255 / 160 ] }
4  { set eta [ expr $eta * 255 / 128 ] }
}
set etamin [expr $eta/60 ]
set etarest  [expr $eta % 60 ]
set fmteta "%02d:%02d"
set etadisplay [format $fmteta $etamin $etarest]
.c.c6a.etasec configure -text $etadisplay
}

proc disp_progress { actseg totseg } {
.c.c6a.txprogress delete all
.c.c6a.txprogress create rectangle  0 0 [ expr $actseg/2 ]  4 -fill green
.c.c6a.txprogress create rectangle  [ expr $totseg/2]   0 200 4  -fill grey86
}


proc init_fix_progress { } {
# first open bsr.binf file
if { [ catch { set fpfix [open "./bsrfix/bsr.bin" r ] } ] } {
   puts "Cannot open ./bsrfix/bsr.bin for reading "
  } else {
    .c.c6a.txprogress create rectangle 0 0 200 4 -fill green
    gets $fpfix regel1    
    gets $fpfix regel1
    gets $fpfix regel1  
#   now at start of missing segs
    set curseg 0
    while { $curseg != -99 } {
    gets $fpfix curseg     
    puts "curseg in bsr.bin  is $curseg"
    if { $curseg == -99 } {
       close $fpfix
       continue
     } else {
# display curseg in red
     .c.c6a.txprogress create line [ expr $curseg/2 ] 0  [ expr $curseg/2 ] 4 -fill red
    }     
  }
 }
}


proc disp_fix_progress { actseg  } {
  .c.c6a.txprogress create line [ expr $actseg/2 ] 0  [ expr $actseg/2 ] 4 -fill green
}


   

wm title . "TXAMADRM - PA0MBO"

wm protocol . WM_DELETE_WINDOW {
  if { [ tk_messageBox -message "Quit?" -type yesno ] eq "yes" } {
   exit
  }
}


ttk::frame .c  -width 900 -height 600
.c configure -padding "5 10"
grid .c -column 0 -row 0 -sticky nw

# get the last tx settings from txamadrm.ini

set HOMEDIR $::env(HOME)
if { [ file exists "$HOMEDIR/txamadrm.ini" ] } {
set nameini "$HOMEDIR/txamadrm.ini"
} else {
set nameini "$HOMEDIR/txamadrm.ini"
exec cp ./txamadrm.ini $HOMEDIR
}

set fpini [open $nameini r]
gets $fpini regel1
gets $fpini regel2
# now get line with devout=0
gets $fpini regel3        
set input [split $regel3 "="]
set devout  [ lindex $input 1 ]
gets $fpini regel4
gets $fpini regel5
set input [split $regel5 "="]
set mode [ lindex $input 1 ]
gets $fpini regel6
set input [split $regel6 "="]
set bw [ lindex $input 1 ]
gets $fpini regel7
set input [split $regel7 "=" ]
set intlv [ lindex $input 1 ]
gets $fpini regel8
set input [split $regel8 "="]
set qam [ lindex $input 1 ]
gets $fpini regel9
set input [split $regel9 "=" ]
set prot [ lindex $input 1 ]
gets $fpini regel10
gets $fpini regel11
set input [split $regel11 "=" ]
set callsign [ lindex $input 1 ]
gets $fpini regel12
gets $fpini regel13
set input [split $regel13 "=" ]
set devptt [ lindex $input 1 ]
gets $fpini regel14
gets $fpini regel15
set input [split $regel15 "=" ]
set catbaud [ lindex $input 1]
gets $fpini regel16
set input [split $regel16 "=" ]
set pttkind [ lindex $input 1 ]
puts "pttkind is $pttkind"
gets $fpini regel17
gets $fpini regel18
set input [split $regel18 "=" ]
set modelnr [ lindex $input 1 ]
gets $fpini regel19
gets $fpini regel20
set input [split $regel20 "=" ]
set rsencodenr [ lindex $input 1]
close $fpini

# set hardware ptt off
set ptt 0 

# make the major frames in which to arrange buttons etc

set eta 0 
set pttlock 0
ttk::frame .c.c1 -borderwidth 5 -relief raised -width 300 -height 400 
.c.c1 configure -padding "2 2"
grid .c.c1 -column 0 -row 0 -sticky nw


ttk::frame .c.c2 -borderwidth 5 -relief raised -width 800 -height  650
.c.c1 configure -padding "2 2"
grid .c.c2 -row 0 -column 1 -sticky nw -rowspan 7 

ttk::frame .c.c3 -borderwidth 5 -relief raised  -width 300 -height 200 
.c.c3 configure -padding "2 2"
grid .c.c3 -column 0 -row 1  -sticky nw

ttk::frame .c.c4 -borderwidth 5 -relief raised -width 300 -height 200
.c.c4 configure -padding "2 2"
grid .c.c4 -column 0 -row 2 -sticky nw

ttk::frame .c.c4a -borderwidth 5 -relief raised -width 300 -height 200
.c.c4a configure -padding "2 2"
grid .c.c4a -column 0 -row 4 -sticky nw

ttk::frame .c.c5 -borderwidth 5 -relief raised -width 300 -height 50
.c.c5 configure -padding "2 2"
grid .c.c5 -column 0 -row 5 -sticky nw

ttk::frame .c.c6 -borderwidth 5 -relief raised -width 100 -height 40
.c.c6 configure -padding "2 2"
grid .c.c6 -column 0 -row 3 -sticky nw

ttk::frame .c.c6a -borderwidth 5 -relief raised -width 100 -height 25
.c.c6a configure -padding "2 2"
grid .c.c6a -column 0 -row 6 -sticky nw

ttk::frame .c.c6b -borderwidth 5 -relief raised -width 50 -height 25
.c.c6b configure -padding "2 2"
grid .c.c6b -column 0 -row 7   -sticky nw


ttk::frame .c.c6c -borderwidth 5 -relief raised -width 50 -height 25
.c.c6c configure -padding "2 2"
grid .c.c6c -column 1  -row 7   -sticky ne


ttk::frame .c.c7 -borderwidth 5 -relief raised -width 1000 -height 25
.c.c7 configure -padding "2 2"
grid .c.c7 -column 0 -row 8 -columnspan 2 -sticky nw 


# Robustness Mode table
ttk::label .c.c1.mode -text "Mode"
grid .c.c1.mode -column 0 -row 0 -sticky nw
 
ttk::radiobutton .c.c1.a -text "A" -variable mode  -value 0 -command {
calcdisp_eta $fileresp
}
grid .c.c1.a -column 1 -row 0 -sticky nw

ttk::radiobutton .c.c1.b -text "B" -variable mode -value 1  -command {
calcdisp_eta $fileresp
}
grid .c.c1.b -column 2 -row 0 -sticky nw

ttk::radiobutton .c.c1.e -text "E" -variable mode  -value 2 -command {
calcdisp_eta $fileresp
}
grid .c.c1.e -column 3 -row 0 -sticky nw

# QAM table
ttk::label .c.c1.qam -text "QAM"
grid .c.c1.qam -column 0 -row 1 -sticky nw
 
ttk::radiobutton .c.c1.q64 -text "64" -variable qam  -value 64 -command {
calcdisp_eta $fileresp
}
grid .c.c1.q64 -column 1 -row 1 -sticky nw

ttk::radiobutton .c.c1.q16 -text "16" -variable qam -value 16 -command {
calcdisp_eta $fileresp
}
grid .c.c1.q16 -column 2 -row 1 -sticky nw

ttk::radiobutton .c.c1.q4 -text "4" -variable qam  -value 4 -command {
calcdisp_eta $fileresp
}
grid .c.c1.q4 -column 3 -row 1 -sticky nw

# Protection level
ttk::label .c.c1.prot -text "Prot"
grid .c.c1.prot -column 0 -row 2 -sticky nw

ttk::radiobutton .c.c1.protN -text "Norm" -variable prot -value 0
grid .c.c1.protN -column 1 -row 2 -sticky nw

ttk::radiobutton .c.c1.protL -text "Low" -variable prot -value 1
grid .c.c1.protL -column 2 -row 2 -sticky nw

# interleaving
ttk::label .c.c1.intlv -text "Intlv"
grid .c.c1.intlv -column 0 -row 3 -sticky nw

ttk::radiobutton .c.c1.ilvL -text "Long" -variable intlv -value 0
grid .c.c1.ilvL -column 1 -row 3 -sticky nw

ttk::radiobutton .c.c1.ilvS -text "Short" -variable intlv -value 1
grid .c.c1.ilvS -column 2 -row 3 -sticky nw


# Bandwidth
ttk::label .c.c1.bw -text "BandWidth"
grid .c.c1.bw -column 0 -row 4 -sticky nw

ttk::radiobutton .c.c1.bws -text "2.2" -variable bw -value 0
grid .c.c1.bws -column 1 -row 4 -sticky nw

ttk::radiobutton .c.c1.bwl -text "2.5" -variable bw -value 1
grid .c.c1.bwl -column 2 -row 4 -sticky nw

# make display room for the picture to load
ttk::label .c.c2.plaatje
grid .c.c2.plaatje -row 0 -column 0 

text .c.c2.txtfile  -width 100 -height 50 

ttk::button .c.c2.savetxt -text "SaveTxT" -command {
set txtdata [ .c.c2.txtfile get 1.0  end   ]
set savfilid [ open $fileresp w ]
puts -nonewline $savfilid $txtdata
close $savfilid 
}

set fidlastrx [ open "lasttx.txt" r ]
gets $fidlastrx  filenametrimmed
close $fidlastrx

if { [regexp jp2$ $filenametrimmed match protocol] } {
puts "filename to conv is $filenametrimmed"
if { [ catch { exec jasper --input $filenametrimmed --output-format jpg --output ./pics/tmp.jpg } ] } {
 puts "jasper error"
}
} else {
  exec convert $filenametrimmed ./pics/tmp.jpg
}


image create photo dagmar -height 585 -width 795 -file ./pics/tmp.jpg
.c.c2.plaatje configure -image dagmar

#set fileresp "./pics/dagmar.jpg"
set fileresp $filenametrimmed


# entry boxes for miscellanious settings
ttk::label .c.c3.calltxt -text "CallSign"
grid .c.c3.calltxt -column 0 -row 0 -sticky nw

ttk::entry .c.c3.entrcall -textvariable callsign 
grid .c.c3.entrcall -column 1 -row 0 -sticky nw

ttk::label .c.c3.nrinst -text "Instances"
grid .c.c3.nrinst -column 0 -row 1 -sticky nw

ttk::entry .c.c3.entrinst -textvariable nrinst
grid .c.c3.entrinst -column 1 -row 1 -sticky nw

set nrinst 1


set filetrim "dagmar.jpg"

# buttons for loading the picture en to start Tx

set ftypes {
  {{all} * }
  {{jp2000} {.jp2}}
  {{jpegs}  {.jpg}}
  {{png} {.png}}
  {{rs2} {.rs2}}
  {{Text Files} {.txt}}
}

ttk::button .c.c4.loadfile -text "Load File" -command {
cd  ./pics 
grid .c.c2.plaatje -row 0 -column 0 
set fileresp [tk_getOpenFile -filetypes $ftypes -initialdir ./pics ]
puts "fileresp is $fileresp"
if { [ catch { file copy -force   $fileresp ./ } ] } {
puts "catched copy error"
cd ../
} else {
set strtpos [ string last "/" $fileresp  ]
puts stdout $strtpos
set endname [string length $fileresp ]
set filetrim [string range $fileresp $strtpos $endname ]
set fileresp "./pics"
append fileresp $filetrim
puts stdout $fileresp
set txfile_content $fileresp

cd ../

calcdisp_eta $fileresp
 
# now test if .txt-file
if { [regexp  txt$  $filetrim  match  protocol ] } {
# puts stdout $match
# puts stdout $protocol
set rsencode_store $rsencodenr
set rsencodenr 0  
grid forget .c.c2.plaatje

.c.c2.txtfile delete 1.0 end
grid .c.c2.txtfile -column 0 -row 0
grid .c.c2.savetxt -column 1 -row 0

set fptxt [open $fileresp r]

set txtinfile  [ read $fptxt ] 

.c.c2.txtfile insert 0.1 $txtinfile


} elseif { [regexp jp2$ $filetrim match protocol ] } {
puts stdout $match
puts stdout $protocol
grid forget .c.c2.txtfile
grid forget .c.c2.savetxt
grid forget .c.c2.plaatje
if { [catch { exec jasper --input $fileresp --output-format jpg --output ./pics/tmp.jpg } ] } {
puts stdout "fileresp is $fileresp"
puts stdout "jasper error"
}

image create photo dagmar -height 600 -width 800 -file ./pics/tmp.jpg
.c.c2.plaatje configure -image dagmar
set fidlasttx [ open "lasttx.txt" w ]
puts $fidlasttx $fileresp
close $fidlasttx
grid .c.c2.plaatje -row 0 -column 0
} elseif { [regexp png$ $filetrim match protocol ] } {
puts stdout $match
puts stdout $protocol

grid forget .c.c2.plaatje
if { [catch { exec convert -quality 60% $fileresp  ./pics/tmp.jpg } ] } {
puts stdout "fileresp is $fileresp"
puts stdout "convert error"
}

image create photo dagmar -height 600 -width 800 -file ./pics/tmp.jpg
.c.c2.plaatje configure -image dagmar
set fidlasttx [ open "lasttx.txt" w ]
puts $fidlasttx $fileresp
close $fidlasttx
grid .c.c2.plaatje -row 0 -column 0

} else {
grid forget .c.c2.txtfile
grid forget .c.c2.savetxt
grid .c.c2.plaatje -row 0 -column 0

image create photo dagmar -height 600 -width 800 -file $fileresp
.c.c2.plaatje configure -image dagmar
set fidlasttx [ open "lasttx.txt" w ]
puts $fidlasttx $fileresp
close $fidlasttx 
}
}
}
grid .c.c4.loadfile -column 0 -row 0 -sticky nw


ttk::button .c.c4a.bsr -text "TX BSR" -command {
set fileresp  "bsr.bin"
if { [ catch { exec  cp $fileresp ./pics } ] } {
puts "cannot find bsr.bin"
} 
set fileresp "./pics/bsr.bin"
puts stdout "sending $fileresp"
set txfile_content $fileresp
set rsencode_store $rsencodenr
set rsencodenr 0
# now calculate eta from size and tx-condx
calcdisp_eta $fileresp

#   display of picture with Ready to TX bsr.bin

image create photo dagmar -height 480 -width 640 -file  ./txbsr.jpg
.c.c2.plaatje configure -image dagmar
grid  .c.c2.plaatje -column 0 -row 0

# here code to transmit waterfall text "BSR"
set data "   BSR\n"
set fpwfal [open "wfal.txt" w]
puts $fpwfal $data
close $fpwfal
if {$ptt == 0} {
.c.c4.txonoff configure -text "SET TXOFF"
#   set ptt 
set ptt 1
ptt_on $modelnr $devptt $catbaud $pttkind
set timeout 100
spawn ./txwfal $devout
expect "finish" {
 ptt_off $modelnr $devptt $catbaud $pttkind
 if { ( $pttkind == "cat" ) || ( $pttkind == "none" ) } {
  }  else {
            set spawnwfal $spawn_id
            set pidwfal [exp_pid -i $spawnwfal]
            exec kill -9 $pidwfal
            puts "else clause van cat in expect BSR"
  }
}
set spawnwfal $spawn_id
set pidwfal [exp_pid -i $spawnwfal]
exec kill -9 $pidwfal
.c.c4.txonoff configure -text "SET TXON"
}

# set ptt off

.c.c4.txonoff configure -text "SET TXON"
set ptt 0
ptt_off $modelnr $devptt $catbaud $pttkind

# end inserted code wfal BSR
.c.c4.txonoff configure -text "SET TXOFF"
set ptt 1
#   set ptt 
ptt_on $modelnr $devptt $catbaud $pttkind

# prepare the txamadrm.ini file
WriteIni  $nameini $devout $mode $bw $intlv $qam $prot $callsign $devptt $catbaud $modelnr $rsencodenr $pttkind

rsencode $rsencodenr $fileresp

#  escape spaces in file name
set tmpstring [string map { "\ " "\\ " } $filetosend ]
set txfiles "spawn ./drm "
append txfiles $tmpstring
puts "txfiles is $txfiles "

#init some stat variables
set actseg 0
set totseg 0
set dumtxt "iSegmCntBody"
set dumtxt2 "blastseg"
set blastseg 0

set keepgoing 1
set ronde 0
set eindinzicht 0
set voorloop 1
set vorigseg 0

#start with file not coded as rs yet
set totcntseg 0

eval $txfiles
set spawndrm $spawn_id
while { $keepgoing } {

expect {

"iSegmCntBody" {
expect "\n" {
set rxtext $expect_out(buffer)
scan $rxtext { %d %s %d %s %d} actseg  dumtxt totseg dumtxt2 blastseg
.c.c5.actseg configure -text $actseg
.c.c5.totseg configure -text $totseg


incr totcntseg 

if {  $eindinzicht == 0 && $voorloop == 0 } {
   set etanew [ expr $eta *( $totseg - $actseg) / $totseg ] 
   set fmteta "%02d:%02d"
   set etadisplay [format $fmteta  [expr $etanew / 60] [expr $etanew % 60] ]
   .c.c6a.etasec configure -text $etadisplay
   disp_progress $actseg $totseg
}

if {  $totcntseg > 9  } {
    set voorloop 0
}
set vorigseg $actseg
if { $blastseg == 1 } {
    incr ronde
   }
if { $ronde == 3 } {
    set eindinzicht 1
}
if { $eindinzicht == 1   && $totcntseg > 16 }  {
    if { $actseg >= 0  } {
    
         set ptt 0
         ptt_off $modelnr $devptt $catbaud $pttkind
         set  piddrm [exp_pid -i $spawndrm]
         exec kill  -9 $piddrm
         .c.c4.txonoff configure -text "SET TXON"
         set keepgoing 0
         set vorigseg 0
     }
   }
  } 
}

}
}
set rsencodenr $rsencode_store
# end of clause  keepgoing 
# now set picture bsr has been sent
image create photo dagmar -height 480 -width 640 -file ./txbsrdone.jpg
.c.c2.plaatje configure -image dagmar
grid .c.c2.plaatje -column 0 -row 0

}
grid .c.c4a.bsr -row 0 -column 0
# =============== END OF CODE TX BSR  ==================

ttk::button .c.c4a.fix -text "TX FIX" -command {
set fidlastrx [ open "lasttx.txt" r ]
gets $fidlastrx  filenametrimmed
close $fidlastrx
init_fix_progress
set fileresp $filenametrimmed
set fileresp $filenametrimmed
puts stdout " fixing $fileresp"
set txfile_content $fileresp

set filesize [ file size $fileresp ]
puts "filesize is "
puts $filesize
.c.c6a.etasec configure -text "fixing"

# display fix file loaded ready to tx
image create photo dagmar -height 480 -width 640 -file  ./fixtx.jpg
.c.c2.plaatje configure -image dagmar
grid  .c.c2.plaatje -column 0 -row 0
# here code to transmit waterfall text "FIX"
set data "   FIX\n"
set fpwfal [open "wfal.txt" w]
puts $fpwfal $data
close $fpwfal
if {$ptt == 0} {
.c.c4.txonoff configure -text "SET TXOFF"
#   set ptt 
set ptt 1
ptt_on $modelnr $devptt $catbaud $pttkind
set timeout 100
spawn ./txwfal $devout
expect "finish" {
 ptt_off $modelnr $devptt $catbaud $pttkind
 if { ( $pttkind == "cat" ) || ( $pttkind == "none" ) } {
  }  else {
            set spawnwfal $spawn_id
            set pidwfal [exp_pid -i $spawnwfal]
            exec kill -9 $pidwfal
            puts "else clause van cat in expect of FIX finish"
  }
}
set spawnwfal $spawn_id
set pidwfal [exp_pid -i $spawnwfal]
exec kill -9 $pidwfal
            puts "na expect finish"
.c.c4.txonoff configure -text "SET TXON"
}
# set ptt off

.c.c4.txonoff configure -text "SET TXON"
set ptt 0
ptt_off $modelnr $devptt $catbaud $pttkind

# start code command txonoff #############################

.c.c4.txonoff configure -text "SET TXOFF"
set ptt 1
#   set ptt 
ptt_on $modelnr $devptt $catbaud $pttkind

# prepare the txamadrm.ini file
WriteIni  $nameini $devout $mode $bw $intlv $qam $prot $callsign $devptt $catbaud $modelnr $rsencodenr $pttkind

rsencode $rsencodenr $fileresp

#  escape spaces in file name
set tmpstring [string map { "\ " "\\ " } $filetosend ]
set txfiles "spawn ./drm "
append txfiles $tmpstring


#init some stat variables
set actseg 0
set totseg 0
set dumtxt "iSegmCntBody"
set dumtxt2 "blastseg"
set blastseg 0

set keepgoing 1
set ronde 0
set eindinzicht 0
set voorloop 1
set vorigseg 0
set extra 0

eval $txfiles
set spawndrm $spawn_id
while { $keepgoing } {

expect {

"iSegmCntBody" {
expect "\n" {
set rxtext $expect_out(buffer)
scan $rxtext { %d %s %d %s %d} actseg  dumtxt totseg dumtxt2 blastseg
.c.c5.actseg configure -text $actseg
.c.c5.totseg configure -text $totseg

disp_fix_progress $actseg 

#if {  $eindinzicht == 0 && $voorloop == 0 } {
#   set etanew [ expr $eta *( $totseg - $actseg) / $totseg ] 
#   set fmteta "%02d:%02d"
#   set etadisplay [format $fmteta  [expr $etanew / 60] [expr $etanew % 60] ]
#   .c.c6a.etasec configure -text $etadisplay
# }

if { $blastseg == 1 } {
set voorloop 0
set vorigseg $actseg
}

if {   $voorloop == 0 && $actseg < $vorigseg  } {
incr ronde
}
set vorigseg $actseg

if { $ronde == $nrinst  } {
    set eindinzicht 1
}
if { $eindinzicht == 1}  {
    incr extra
    if { $extra > 8 } {
         set ptt 0
         ptt_off $modelnr $devptt $catbaud $pttkind
         set  piddrm [exp_pid -i $spawndrm]
         exec kill  -9 $piddrm
         .c.c4.txonoff configure -text "SET TXON"
         set keepgoing 0
         set vorigseg 0
     }
   }
  } 
}

}
}
# now change text picture to pic of FIX-FILE SENT
image create photo dagmar -height 480 -width 640 -file ./txfixdone.jpg
.c.c2.plaatje configure -image dagmar
grid .c.c2.plaatje -column 0 -row 0
#sleep 2
#image create photo dagmar -height 640 -width 640 -file ./pics/tmp.jpg
#.c.c2.plaatje configure -image dagmar
#grid .c.c2.plaatje -column 0 -row 0

}
grid .c.c4a.fix -row 0 -column 1 -sticky nw
#  ======= END TX FIX CODE ===========

ttk::radiobutton .c.c6.makers0 -text "none"  -variable rsencodenr -value 0 -command {
calcdisp_eta $fileresp
}
grid .c.c6.makers0 -column 0 -row 0 -sticky nw

ttk::radiobutton .c.c6.makers1 -text "rs1"  -variable rsencodenr -value 1 -command {
calcdisp_eta $fileresp
}
grid .c.c6.makers1 -column 1 -row 0 -sticky nw

ttk::radiobutton .c.c6.makers2 -text "rs2"  -variable rsencodenr -value 2 -command {
calcdisp_eta $fileresp
}
grid .c.c6.makers2 -column 2 -row 0 -sticky nw

ttk::radiobutton .c.c6.makers3 -text "rs3"  -variable rsencodenr -value 3 -command {
calcdisp_eta $fileresp
}
grid .c.c6.makers3 -column 3 -row 0 -sticky nw

ttk::radiobutton .c.c6.makers4 -text "rs4"  -variable rsencodenr -value 4  -command {
calcdisp_eta $fileresp
}
grid .c.c6.makers4 -column 4 -row 0 -sticky nw



init_ptt $modelnr $devptt $catbaud $pttkind

ttk::button .c.c4.txonoff  -text "SET TXON"  -command { 
if {$ptt == 0} {
.c.c4.txonoff configure -text "SET TXOFF"
set ptt 1

if { [ catch { exec rm ./picsrx/bsr.bin} ] } {
}

#   set ptt 
ptt_on $modelnr $devptt $catbaud $pttkind

# prepare the txamadrm.ini file
WriteIni  $nameini $devout $mode $bw $intlv $qam $prot $callsign $devptt $catbaud $modelnr $rsencodenr $pttkind

rsencode $rsencodenr $fileresp

#  escape spaces in file name
set tmpstring [string map { "\ " "\\ " } $filetosend ]
set txfiles "spawn ./drm "
append txfiles $tmpstring
puts "txfiles is $txfiles "
eval $txfiles

set spawndrm $spawn_id

#init some stat variables
set actseg 0
set totseg 0
set dumtxt "iSegmCntBody"
set dumtxt2 "blastseg"
set blastseg 0

set keepgoing 1
set ronde 0
set eindinzicht 0
set voorloop 1
set vorigseg 0

#start with file not coded as rs yet

while { $keepgoing } {

expect {

"iSegmCntBody" {
expect "\n" {
set rxtext $expect_out(buffer)
scan $rxtext { %d %s %d %s %d} actseg  dumtxt totseg dumtxt2 blastseg
.c.c5.actseg configure -text $actseg
.c.c5.totseg configure -text $totseg


if {  $eindinzicht == 0 && $voorloop == 0 } {
   set etanew [ expr $eta *( $totseg - $actseg) / $totseg ] 
   set fmteta "%02d:%02d"
   set etadisplay [format $fmteta  [expr $etanew / 60] [expr $etanew % 60] ]
   .c.c6a.etasec configure -text $etadisplay
   disp_progress $actseg $totseg
}
if {  $actseg < $vorigseg } {
    set voorloop 0
}
set vorigseg $actseg
if { $blastseg == 1 } {
    incr ronde
   }
if { $ronde == $nrinst +1 } {
    set eindinzicht 1
}
if { $eindinzicht == 1}  {
    if { $actseg == 9 } {
    
         set ptt 0
         ptt_off $modelnr $devptt $catbaud $pttkind
         set  piddrm [exp_pid -i $spawndrm]
         exec kill  -9 $piddrm
         .c.c4.txonoff configure -text "SET TXON"
         set keepgoing 0
         set vorigseg 0
     }
   }
  } 
}

}
}

} else {         
# ptt was on               
.c.c4.txonoff configure -text "SET TXON"
set ptt 0
ptt_off $modelnr $devptt $catbaud $pttkind
set  piddrm [exp_pid -i $spawndrm]
exec kill  -9 $piddrm
set keepgoing 0
# now check if file sent was ./txt file if so, restore rsencodenr
puts "filenamelast is $fileresp"
if { [regexp  txt$  $fileresp  match  protocol ] } {
puts "file sent was .txt file  $fileresp"
set rsencodenr $rsencode_store
}
}
}

grid .c.c4.txonoff -column 1 -row 0 -sticky nw
# ============== END OF CODE SET TXON BUTTON

ttk::label .c.c5.lbltotseg -text "tot segmnts       "
grid .c.c5.lbltotseg -column 0 -row 0 -sticky nw

ttk::label .c.c5.lblactseg -text "act segmnts"
grid .c.c5.lblactseg -column 1 -row 0 -sticky nw

ttk::label .c.c5.actseg -text "0"
grid .c.c5.actseg -column 1 -row 1 -sticky nw

ttk::label .c.c5.totseg -text "0"
grid .c.c5.totseg -column 0 -row 1 -sticky nw

ttk::label .c.c6a.eta -text "Est. Time Arriv (min)  "
grid .c.c6a.eta -column 0 -row 0 -sticky nw

ttk::label .c.c6a.etasec -text $eta
grid .c.c6a.etasec -column 1 -row 0 -sticky nw

tk::canvas .c.c6a.txprogress -background black -width 200 -height 4 
grid .c.c6a.txprogress -column 0 -row 1 -columnspan 2 -sticky nw

ttk::button .c.c6b.wfaltxt -text "WFALLTXT" -command {
if { $ptt == 0 } {
toplevel .wfaltxt
wm title .wfaltxt "WFALLTXT"

ttk::frame .wfaltxt.c  -width 900 -height 600
.wfaltxt.c configure -padding "5 10"
grid .wfaltxt.c -column 0 -row 0 -sticky nw

ttk::frame .wfaltxt.c.c1 -borderwidth 5 -relief raised -width 300 -height 400 
.wfaltxt.c.c1 configure -padding "2 2"
grid .wfaltxt.c.c1 -column 0 -row 0 -sticky nw

ttk::frame .wfaltxt.c.c2 -borderwidth 5 -relief raised -width 300 -height 200 
grid .wfaltxt.c.c2 -column 0 -row 1 -sticky nw

#ttk::frame .wfaltxt.c.c3 -borderwidth 5 -relief raised -width 300 -height 200
# .wfaltxt.c.c3 configure -padding "2 2"
#grid .wfaltxt.c.c3 -column 0 -row 1 -sticky nw

ttk::button .wfaltxt.c.c1.abort -text  "CLEARTXT" -command {
.wfaltxt.c.c1.txtfile delete 1.0 end
}
grid .wfaltxt.c.c1.abort -column 0 -row 0

text .wfaltxt.c.c1.txtfile -width 10 -height 3

set fpwfal [open "wfal.txt" r]
set txtinfile [read $fpwfal]

.wfaltxt.c.c1.txtfile delete 1.0 end
.wfaltxt.c.c1.txtfile insert 0.1 $txtinfile
grid .wfaltxt.c.c1.txtfile -column 1 -row 0 
  
ttk::button .wfaltxt.c.c1.wfal -text "SET TXON" -command {
set data [ .wfaltxt.c.c1.txtfile get 1.0 end ]
set fpwfal [open "wfal.txt" w]
puts $fpwfal $data
close $fpwfal
if {$ptt == 0} {
.wfaltxt.c.c1.wfal configure -text "SET TXOFF"
#   set ptt 
set ptt 1
ptt_on $modelnr $devptt $catbaud $pttkind
set timeout 100
spawn ./txwfal $devout
set spawnwfal $spawn_id
expect "finish" {
            ptt_off $modelnr $devptt $catbaud $pttkind
}
# .wfaltxt.c.c1.wfal configure -text "SET TXON"
} else {
            set pidwfal [exp_pid -i $spawnwfal]
            exec kill -9 $pidwfal
}
# set ptt off
# .wfaltxt.c.c1.wfal configure -text "SET TXON"
set ptt 0
ptt_off $modelnr $devptt $catbaud $pttkind
destroy .wfaltxt
}
grid .wfaltxt.c.c1.wfal -column 2 -row 0

ttk::button .wfaltxt.c.c2.nwtx -text "START TXT" -command {
.wfaltxt.c.c1.txtfile delete 1.0 end
.wfaltxt.c.c1.txtfile insert 1.0  " NW TX\n $callsign\n"
}
grid .wfaltxt.c.c2.nwtx -column 0 -row 1 

ttk::button .wfaltxt.c.c2.gdcpy -text "GD_CPY" -command {
.wfaltxt.c.c1.txtfile delete 1.0 end
.wfaltxt.c.c1.txtfile insert 1.0  " GUD CPY\n $callsign\n"
}
grid .wfaltxt.c.c2.gdcpy -column 1 -row 1

ttk::button .wfaltxt.c.c2.tnx -text "TNX" -command {
.wfaltxt.c.c1.txtfile delete 1.0 end
.wfaltxt.c.c1.txtfile insert 1.0 " TNX RPRT\n  $callsign\n"
}
grid .wfaltxt.c.c2.tnx -column 2 -row 1

ttk::button .wfaltxt.c.c2.bsr -text "QRT" -command {
.wfaltxt.c.c1.txtfile delete 1.0 end
.wfaltxt.c.c1.txtfile insert 1.0 " NW QRT\n VY 73\n $callsign\n"
}
grid .wfaltxt.c.c2.bsr -column 0 -row 2

ttk::button .wfaltxt.c.c2.fix -text "NO MSC" -command {
.wfaltxt.c.c1.txtfile delete 1.0 end
.wfaltxt.c.c1.txtfile insert 1.0 "SRI NO MSC\n $callsign\n"
}
grid .wfaltxt.c.c2.fix -column 1 -row 2

ttk::button .wfaltxt.c.c2.tune -text "TUNE" -command {
if {$ptt == 0} {
.wfaltxt.c.c2.tune configure -text "SET TXOFF"
#   set ptt 
set ptt 1
puts "pttkind in TUNE is $pttkind"
ptt_on $modelnr $devptt $catbaud $pttkind
set timeout 200
spawn ./tunetones $devout
expect "finish" {
 ptt_off $modelnr $devptt $catbaud $pttkind
 if { ( $pttkind == "cat" ) || ( $pttkind == "none" ) } {
  }  else {
            set spawnwfal $spawn_id
            set pidwfal [exp_pid -i $spawnwfal]
            exec kill -9 $pidwfal
  }
}
set spawnwfal $spawn_id
set pidwfal [exp_pid -i $spawnwfal]
exec kill -9 $pidwfal
# .wfaltxt.c.c1.wfal configure -text "SET TXON"
} else {

            set spawnwfal $spawn_id
            set pidwfal [exp_pid -i $spawnwfal]
            exec kill -9 $pidwfal
            set ptt 0
            ptt_off $modelnr $devptt $catbaud $pttkind
            destroy .wfaltxt
}
# set ptt off

# .wfaltxt.c.c2.tune configure -text "TUNE"
set ptt 0
ptt_off $modelnr $devptt $catbaud $pttkind
destroy .wfaltxt
}
grid .wfaltxt.c.c2.tune -column 2 -row 2
}
}
grid .c.c6b.wfaltxt -column 0 -row 0 -sticky w


# HYBRID TX BUTTON

ttk::button .c.c6b.hybrid -text "TX HYBRID" -command {
if { $ptt == 0 } {
   toplevel .hybrid  -height 50 -width 100
   wm title .hybrid "TX HYBRID"
ttk::button .hybrid.abort -text "ABORT" -command {
puts "going to abort hybrid"
ptt_off $modelnr $devptt $catbaud $pttkind
  set pidhybrid [exp_pid -i $spawnhybrid]
  exec kill -9 $pidhybrid
set ptt 0
destroy .hybrid
}
grid .hybrid.abort -column 0 -row 1

ttk::label .hybrid.msgtxt -text "nw ftp-ing picture to server"
grid .hybrid.msgtxt -column 0 -row 0

# run the ftp
# get the  settings from hybrid.ini
set HOMEDIR $::env(HOME)
set hybrini "$HOMEDIR/hybrid.ini"
if { [ file exists "$HOMEDIR/hybrid.ini" ] } {
} else {
exec cp ./hybrid.ini $HOMEDIR
}
set fphybrid [open $hybrini r]
# now get lines from [provider]
gets $fphybrid regel4
gets $fphybrid regel5
set input [split $regel5 "="]
set hybridserver  [ lindex $input 1 ]
#now get lines from [access]
gets $fphybrid regel6
gets $fphybrid regel7
set input [split $regel7 "="]
set hybriduserid [ lindex $input 1 ]
gets $fphybrid regel8
set input [split $regel8 "="]
set hybridpasswd  [ lindex $input 1 ]
#now get lines from [dir]
gets $fphybrid regel9
gets $fphybrid regel10
set input [split $regel10 "=" ]
set hybriddir [ lindex $input 1 ]
#now get lines from [method]
gets $fphybrid regel11
gets $fphybrid regel12
set input [split $regel12 "=" ]
set hybridmethod [ lindex $input 1]
close $fphybrid


# now start ftp program and keep its pid in pidhybrid

set fphybridlast [ open "./lasttx.txt" r ]
gets $fphybridlast hybridfilename
close $fphybridlast

#now manipulate file and file name to be sent to ".de NOCALL-serialno-FileName.xxx"
set hybridprefix "de_$callsign-1-"
set realfilename [ string trimleft $hybridfilename "./pics/" ]

append hybridprefix $realfilename
puts "hybrid with prefix is $hybridprefix"
exec cp $hybridfilename ./pics/$hybridprefix

switch $hybridmethod {

ftp {

spawn  ftp $hybridserver
set pidhybrid [exp_pid -i  $spawn_id]

expect  ":" 
exp_send   "$hybriduserid\r"

expect "Password:"
exp_send  "$hybridpasswd\r"

expect "ftp>"
exp_send "cd $hybriddir\r"

expect "ftp>"
exp_send "bin\r"

expect "ftp>"
exp_send "lcd ./pics\r"

expect "ftp>"
exp_send "prompt\r"

expect "ftp>"
exp_send "mdel de_$callsign*\r"

expect "ftp>"
exp_send "prompt\r"

expect "ftp>"
exp_send "put \"$hybridprefix\"\r"

expect "ftp>"
exp_send "bye\r"

expect "Goodbye."
sleep 2
}


sftp {
puts "using sftp"
spawn  sftp  $hybriduserid@$hybridserver
set pidftp [exp_pid -i  $spawn_id]

expect "assword:"
exp_send  "$hybridpasswd\r"

expect "sftp>"
exp_send "cd $hybriddir\r"

expect "sftp>"
exp_send "put \"$hybridfilename\"\r"


expect "sftp>"
exp_send  "bye\r"

expect "Goodbye."
sleep 2 
}

scp {
puts "using scp"
spawn  scp  $hybriduserid@$hybridserver:$hybriddir/\"$hybridprefix\"
set pidftp [exp_pid -i  $spawn_id]

expect "assword:"
exp_send  "$hybridpasswd\r"


expect $hybridprefix
sleep 2
}
}

}

.hybrid.msgtxt configure -text "ftp finished"

# now start transmission of dummy file
# first change file content to small text

# set fpdum [open ./pics/$hybridprefix "w"]
# puts $fpdum "with the compliments of N0CALL"
#  close $fpdum

 exec cp ./pics/stdserver ./pics/$hybridprefix
 exec ./getserverid ./pics/$hybridprefix


# Now set ptt and write current tx parameters
WriteIni  $nameini $devout $mode $bw $intlv $qam $prot $callsign $devptt $catbaud $modelnr $rsencodenr $pttkind
set ptt 1
ptt_on $modelnr $devptt $catbaud $pttkind
.hybrid.msgtxt configure -text "PTT SET"
set timeout 1000
spawn ./hybrid ./pics/$hybridprefix
set spawnhybrid $spawn_id
expect "round 40" {
  ptt_off $modelnr $devptt $catbaud $pttkind
  set pidhybrid [exp_pid -i $spawnhybrid]
  exec kill -9 $pidhybrid
}
set ptt 0
ptt_off $modelnr $devptt $catbaud $pttkind
.hybrid.msgtxt configure -text "PTT RESET"
set pidhybrid [exp_pid -i $spawnhybrid]
exec kill -9 $pidhybrid
destroy .hybrid
}
grid .c.c6b.hybrid -column 1 -row 0 -sticky nw


# widgets / radiobuttons to set kind of PTT

ttk::label .c.c6c.pttlabel -text "PTT        " 
grid .c.c6c.pttlabel -column 0 -row 0 -sticky nw

ttk::radiobutton .c.c6c.pttcat -text "CAT" -variable pttkind -value "cat" -command {
if { [ catch { close $fdin } ] } {
}
.c.c7.pttdev configure -text "CAT dev"
puts "cat radiobutton operated"
set catbaud ""
set modelnr ""
set devptt ""
.c.c7.valbaud configure -state normal
.c.c7.modelnrcontent configure -state normal
.c.c7.pttdevnr configure -state normal
}
grid .c.c6c.pttcat -column 1 -row 0 -sticky nw

ttk::radiobutton .c.c6c.pttrts -text "RTS" -variable pttkind -value "rts" -command {
if { [ catch { close $fdin } ] } {
}
.c.c7.pttdev configure -text "PTT dev " 
.c.c7.pttdevnr configure -state normal
.c.c7.valbaud configure -state disabled
.c.c7.modelnrcontent configure -state disabled
puts "rts button operated"
}
grid .c.c6c.pttrts -column 2 -row 0 -sticky nw

ttk::radiobutton .c.c6c.pttdtr -text "DTR" -variable pttkind -value "dtr" -command {
if { [ catch { close $fdin } ] } {
}
.c.c7.pttdev configure -text "PTT dev "
.c.c7.pttdevnr configure -state normal
.c.c7.valbaud configure -state disabled
.c.c7.modelnrcontent configure -state disabled 
puts "dtr button operated"
}
grid .c.c6c.pttdtr -column 3 -row 0 -sticky nw

ttk::radiobutton .c.c6c.pttnone -text "None" -variable pttkind -value "none" -command {
if { [ catch { close $fdin } ] } {
puts "could not close fdin"
}
.c.c7.pttdev configure -text "Serial Dev" 
.c.c7.pttdevnr configure -state disabled
.c.c7.valbaud configure -state disabled
.c.c7.modelnrcontent configure -state disabled 
puts "none button operated"
}
grid .c.c6c.pttnone -column 4 -row 0 -sticky nw

ttk::button .c.c6c.iniptt -text "  SAVE CFG" -command  {
# get the last tx settings from txamadrm.ini
set nameini "$HOMEDIR/txamadrm.ini"
set fpini [open $nameini r]
gets $fpini regel1
gets $fpini regel2
# now get line with devout=0
gets $fpini regel3        
set input [split $regel3 "="]
set devoutold  [ lindex $input 1 ]
gets $fpini regel4
gets $fpini regel5
set input [split $regel5 "="]
set modeold [ lindex $input 1 ]
gets $fpini regel6
set input [split $regel6 "="]
set bwold [ lindex $input 1 ]
gets $fpini regel7
set input [split $regel7 "=" ]
set intlvold [ lindex $input 1 ]
gets $fpini regel8
set input [split $regel8 "="]
set qamold [ lindex $input 1 ]
gets $fpini regel9
set input [split $regel9 "=" ]
set protold [ lindex $input 1 ]
gets $fpini regel10
gets $fpini regel11
set input [split $regel11 "=" ]
set callsignold [ lindex $input 1 ]
gets $fpini regel12
gets $fpini regel13
set input [split $regel13 "=" ]
set devpttold [ lindex $input 1 ]
gets $fpini regel14
gets $fpini regel15
set input [split $regel15 "=" ]
set catbaudold [ lindex $input 1]
gets $fpini regel16
set input [split $regel16 "=" ]
set pttkindold [ lindex $input 1 ]
puts "pttkind is $pttkind"
gets $fpini regel17
gets $fpini regel18
set input [split $regel18 "=" ]
set modelnrold [ lindex $input 1 ]
gets $fpini regel19
gets $fpini regel20
set input [split $regel20 "=" ]
set rsencodenrold [ lindex $input 1]
close $fpini
WriteIni $nameini $devout $mode $bw $intlv $qam $prot $callsign $devptt $catbaud $modelnr $rsencodenr $pttkind
   init_ptt $modelnr $devptt $catbaud $pttkind
}
grid .c.c6c.iniptt -column 5 -row 0 -sticky nw
# button to set sound device

ttk::menubutton .c.c7.snddev -menu .c.c7.snddev.m -text "SET SND DEV"
menu .c.c7.snddev.m
.c.c7.snddev.m add command -label "set dev=0" -command { set devout 0 }
.c.c7.snddev.m add command -label "set dev=1" -command { set devout 1 }
.c.c7.snddev.m add command -label "set dev=2" -command { set devout 2 }
grid .c.c7.snddev -column 2 -row 0 -sticky nw

ttk::entry .c.c7.devnr -textvariable devout  -width 2
grid .c.c7.devnr -column 3 -row 0 -sticky nw

# entry to set PTT device
ttk::label .c.c7.pttdev -text "PTT dev"
grid .c.c7.pttdev -column 4 -row 0 -sticky nw

ttk::entry .c.c7.pttdevnr -textvariable devptt -width 13
grid .c.c7.pttdevnr -column 5 -row 0 -sticky nw

# button to set baudrate CAT

ttk::menubutton .c.c7.catbaud -menu .c.c7.catbaud.m -text "Set Baud"
menu .c.c7.catbaud.m 
.c.c7.catbaud.m add command -label "1200" -command { set catbaud 1200 } 
.c.c7.catbaud.m add command -label "4800" -command { set catbaud 4800 } 
.c.c7.catbaud.m add command -label "9600" -command { set catbaud 9600 } 
.c.c7.catbaud.m add command -label "19200" -command { set catbaud 19200 } 
.c.c7.catbaud.m add command -label "38400" -command { set catbaud 38400 } 
grid .c.c7.catbaud -column 6 -row 0 -sticky nw

ttk::entry .c.c7.valbaud -textvariable catbaud -width 6 
if { $pttkind == "none" } {
.c.c7.valbaud configure -state disabled
.c.c7.pttdevnr configure -state disabled
} else {
if { $pttkind == "dtr"  || $pttkind == "rts" } {
.c.c7.valbaud configure -state disabled
}
}  
grid .c.c7.valbaud -column 7 -row 0 -sticky nw

# entry for hamlib transceiver model number
ttk::label .c.c7.modelnr -text "Hamlib model # TRX"
grid .c.c7.modelnr -column 8 -row 0 -sticky nw
ttk::entry .c.c7.modelnrcontent -textvariable modelnr -width 4
if { $pttkind == "none" } {
.c.c7.modelnrcontent configure -state disabled
} else {
if { $pttkind == "dtr"  || $pttkind == "rts" } {
.c.c7.modelnrcontent configure -state disabled
}
}  
grid .c.c7.modelnrcontent -column 9 -row 0 -sticky nw

# label to show Tx-filename
ttk::label .c.c7.txfile -text "TXFILE:  "
grid .c.c7.txfile -column 0 -row 0 -sticky nw
ttk::label .c.c7.txfile_content -textvariable txfile_content -relief sunken
.c.c7.txfile_content configure -width 50
set txfile_content $fileresp
grid .c.c7.txfile_content -column 1 -row 0



